# -*-makefile-*-
# Copyright (C) 2006 by Juergen Beisert <juergen@kreuzholzen.de>
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_CAPIO_INSTALL_XORG_CONF) += fixup-rootfs

# ----------------------------------------------------------------------------
# Get (nothing to do here)
# ----------------------------------------------------------------------------

fixup-rootfs_get: $(STATEDIR)/fixup-rootfs.get

$(STATEDIR)/fixup-rootfs.get:
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Extract (nothing to do here)
# ----------------------------------------------------------------------------

fixup-rootfs_extract: $(STATEDIR)/fixup-rootfs.extract

$(STATEDIR)/fixup-rootfs.extract: $(fixup-rootfs_extract_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare (nothing to do here)
# ----------------------------------------------------------------------------

fixup-rootfs_prepare: $(STATEDIR)/fixup-rootfs.prepare

$(STATEDIR)/fixup-rootfs.prepare: $(fixup-rootfs_prepare_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile (nothing to do here)
# ----------------------------------------------------------------------------

fixup-rootfs_compile: $(STATEDIR)/f_FSTABixup-rootfs.compile

$(STATEDIR)/fixup-rootfs.compile: $(fixup-rootfs_compile_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install (nothing to do here)
# ----------------------------------------------------------------------------

fixup-rootfs_install: $(STATEDIR)/fixup-rootfs.install

$(STATEDIR)/fixup-rootfs.install: $(fixup-rootfs_install_deps_default) $(STATEDIR)/kernel.targetinstall
	@$(call targetinfo, $@)
	@cp $(KERNEL_DIR)/drivers/video/geode_gx1/geode_gx1_fb.h $(SYSROOT)/usr/include
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# do install some special files
# ----------------------------------------------------------------------------

fixup-rootfs_targetinstall: $(STATEDIR)/fixup-rootfs.targetinstall

$(STATEDIR)/fixup-rootfs.targetinstall: $(fixup-rootfs_targetinstall_deps_default)
	@$(call targetinfo, $@)
	@$(call install_init, geode-rootfs)
	@$(call install_fixup,geode-rootfs,PACKAGE,geode-rootfs)
	@$(call install_fixup,geode-rootfs,PRIORITY,optional)
	@$(call install_fixup,geode-rootfs,VERSION,0)
	@$(call install_fixup,geode-rootfs,SECTION,base)
	@$(call install_fixup,geode-rootfs,AUTHOR,"Juergen Beisert")
	@$(call install_fixup,geode-rootfs,DEPENDS,)
	@$(call install_fixup,geode-rootfs,DESCRIPTION,missing)


ifdef PTXCONF_CAPIO_INSTALL_XORG_CONF
	@$(call install_copy, geode-rootfs, 0, 0, 0644, \
		${PTXDIST_WORKSPACE}/projectroot/etc/xorg.conf, \
		/etc/xorg.conf, n)

	@$(call install_replace, geode-rootfs, /etc/xorg.conf, \
		@DEFAULT_PATH@, ${PTXCONF_XORG_DEFAULT_DATA_DIR} )

	@$(call install_replace, geode-rootfs, /etc/xorg.conf, \
		@FONT_SERVER@, ${PTXCONF_CAPIO_FSERVER} )
endif
	@$(call install_finish,geode-rootfs)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

fixup-rootfs_clean:
	@rm -rf $(STATEDIR)/fixup-rootfs.*
	@rm -rf $(IMAGEDIR)/fixup-rootfs_*

# vim: syntax=make
