# -*-makefile-*-
# $Id:$
#
# Copyright (C) 2006 by Juergen Beisert
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_LINUXBIOS) += linuxbios

#
# Paths and names
#
LINUXBIOS_VERSION	:= v2-r2671
LINUXBIOS		:= LinuxBIOS$(LINUXBIOS_VERSION)
LINUXBIOS_SUFFIX	:= tar.bz2
LINUXBIOS_URL		:= http://www.pengutronix.de/software/ptxdist/temporary-src/$(LINUXBIOS).$(LINUXBIOS_SUFFIX)
LINUXBIOS_SOURCE	:= $(SRCDIR)/$(LINUXBIOS).$(LINUXBIOS_SUFFIX)
LINUXBIOS_DIR		:= $(BUILDDIR)/$(LINUXBIOS)

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

linuxbios_get: $(STATEDIR)/linuxbios.get

$(STATEDIR)/linuxbios.get: $(linuxbios_get_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

$(LINUXBIOS_SOURCE):
	@$(call targetinfo, $@)
	@$(call get, LINUXBIOS)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

linuxbios_extract: $(STATEDIR)/linuxbios.extract

$(STATEDIR)/linuxbios.extract: $(linuxbios_extract_deps_default)
	@$(call targetinfo, $@)
	@$(call clean, $(LINUXBIOS_DIR))
	@$(call extract, LINUXBIOS)
	@$(call patchin, LINUXBIOS)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

linuxbios_prepare: $(STATEDIR)/linuxbios.prepare

LINUXBIOS_PATH	:= PATH=$(CROSS_PATH)
LINUXBIOS_ENV 	:= $(CROSS_ENV)

#
# autoconf
#
LINUXBIOS_AUTOCONF := $(CROSS_AUTOCONF_USR)

$(STATEDIR)/linuxbios.prepare: $(linuxbios_prepare_deps_default)
	@$(call targetinfo, $@)
# one configure file for all
	cp $(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb.in \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
# do the screen resolution here for all targets
ifdef PTXCONF_GEODE_RES_640x480
	sed -i -e "s/@VIDEO_MODE@/0/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
endif
ifdef PTXCONF_GEODE_RES_800x600
	sed -i -e "s/@VIDEO_MODE@/1/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
endif
ifdef PTXCONF_GEODE_RES_1024x768
	sed -i -e "s/@VIDEO_MODE@/2/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
endif
ifdef PTXCONF_GEODE_RES_1280x960
	sed -i -e "s/@VIDEO_MODE@/3/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
endif
ifdef PTXCONF_GEODE_RES_1280x1024
	sed -i -e "s/@VIDEO_MODE@/4/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
endif

ifdef PTXCONF_GEODE_SERVER
	sed -i -e "s/@ENA_VIDEO@/0/g" \
		-e "s/@VIDEO_SIZE@/0/g" \
		-e "s/@VIDEO_MODE@/0/g" \
		-e "s/@SMALL_MEMORY@/1/g" \
		-e "s/@LARGE_MEMORY@/0/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
	@rm -rf $(LINUXBIOS_DIR)/targets/asi/winterm100/winterm100
	cd $(LINUXBIOS_DIR)/targets && $(LINUXBIOS_PATH) ./buildtarget asi/winterm100
endif
ifdef PTXCONF_IGEL316_STANDARD
	sed -i -e "s/@ENA_VIDEO@/1/g" \
		-e "s/@VIDEO_SIZE@/4/g" \
		-e "s/@SMALL_MEMORY@/0/g" \
		-e "s/@LARGE_MEMORY@/0/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
	$(HOST_XPM_CONVERTER_DIR)/xpm-converter < $(HOST_XPM_CONVERTER_DIR)/input.xpm \
		> $(LINUXBIOS_DIR)/src/southbridge/amd/cs5530/bitmap.c
	@rm -rf $(LINUXBIOS_DIR)/targets/asi/winterm100/winterm100
	cd $(LINUXBIOS_DIR)/targets && $(LINUXBIOS_PATH) ./buildtarget asi/winterm100
endif
ifdef PTXCONF_IGEL316_TERMINAL_OPTIMISED
	sed -i -e "s/@ENA_VIDEO@/1/g" \
		-e "s/@VIDEO_SIZE@/4/g" \
		-e "s/@SMALL_MEMORY@/1/g" \
		-e "s/@LARGE_MEMORY@/0/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
	$(HOST_XPM_CONVERTER_DIR)/xpm-converter < $(HOST_XPM_CONVERTER_DIR)/input.xpm \
		> $(LINUXBIOS_DIR)/src/southbridge/amd/cs5530/bitmap.c
	@rm -rf $(LINUXBIOS_DIR)/targets/asi/winterm100/winterm100
	cd $(LINUXBIOS_DIR)/targets && $(LINUXBIOS_PATH) ./buildtarget asi/winterm100
endif
ifdef PTXCONF_IGEL316_TERMINAL_LARGE
	sed -i -e "s/@ENA_VIDEO@/1/g" \
		-e "s/@VIDEO_SIZE@/4/g" \
		-e "s/@SMALL_MEMORY@/0/g" \
		-e "s/@LARGE_MEMORY@/1/g" \
		$(LINUXBIOS_DIR)/src/mainboard/asi/winterm100/Options.lb
	$(HOST_XPM_CONVERTER_DIR)/xpm-converter < $(HOST_XPM_CONVERTER_DIR)/input.xpm \
		> $(LINUXBIOS_DIR)/src/southbridge/amd/cs5530/bitmap.c
	@rm -rf $(LINUXBIOS_DIR)/targets/asi/winterm100/winterm100
	cd $(LINUXBIOS_DIR)/targets && $(LINUXBIOS_PATH) ./buildtarget asi/winterm100
endif
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

linuxbios_compile: $(STATEDIR)/linuxbios.compile

$(STATEDIR)/linuxbios.compile: $(linuxbios_compile_deps_default)
	@$(call targetinfo, $@)
	@cd $(LINUXBIOS_DIR)/targets/asi/winterm100/winterm100 && \
	$(LINUXBIOS_PATH) LANG=C $(MAKE) CROSS_COMPILE=$(call remove_quotes,$(PTXCONF_COMPILER_PREFIX))
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

linuxbios_install: $(STATEDIR)/linuxbios.install

$(STATEDIR)/linuxbios.install: $(linuxbios_install_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

linuxbios_targetinstall: $(STATEDIR)/linuxbios.targetinstall

$(STATEDIR)/linuxbios.targetinstall: $(linuxbios_targetinstall_deps_default)
	@$(call targetinfo, $@)
	@cp $(LINUXBIOS_DIR)/targets/asi/winterm100/winterm100/linuxbios.rom \
		$(IMAGEDIR)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

linuxbios_clean:
	@rm -rf $(LINUXBIOS_DIR)/targets/asi/winterm100/winterm100
	@rm -rf $(STATEDIR)/linuxbios.*
	@rm -rf $(IMAGEDIR)/linuxbios.rom
	@rm -rf $(LINUXBIOS_DIR)

# vim: syntax=make
