#
# Copyright (C) 2008 by Juergen Beisert
#
# See CREDITS for details about who has contributed to this project.
#
# For further information about the PTXdist project and license conditions
# see the README file.
#

#
# We provide this package
#
PACKAGES-$(PTXCONF_FTDI_EEPROM) += ftdi_eeprom

#
# Paths and names
#
FTDI_EEPROM_VERSION	:= 0.2
FTDI_EEPROM		:= ftdi_eeprom-$(FTDI_EEPROM_VERSION)
FTDI_EEPROM_SUFFIX	:= tar.gz
FTDI_EEPROM_URL		:= http://www.intra2net.com/de/produkte/opensource/ftdi/TGZ/$(FTDI_EEPROM).$(FTDI_EEPROM_SUFFIX)
FTDI_EEPROM_SOURCE	:= $(SRCDIR)/$(FTDI_EEPROM).$(FTDI_EEPROM_SUFFIX)
FTDI_EEPROM_DIR		:= $(BUILDDIR)/$(FTDI_EEPROM)

# ----------------------------------------------------------------------------
# Get
# ----------------------------------------------------------------------------

ftdi_eeprom_get: $(STATEDIR)/ftdi_eeprom.get

$(STATEDIR)/ftdi_eeprom.get: $(ftdi_eeprom_get_deps_default)
	@$(call targetinfo, $@)
	@$(call touch, $@)

$(FTDI_EEPROM_SOURCE):
	@$(call targetinfo, $@)
	@$(call get, FTDI_EEPROM)

# ----------------------------------------------------------------------------
# Extract
# ----------------------------------------------------------------------------

ftdi_eeprom_extract: $(STATEDIR)/ftdi_eeprom.extract

$(STATEDIR)/ftdi_eeprom.extract: $(ftdi_eeprom_extract_deps_default)
	@$(call targetinfo, $@)
	@$(call clean, $(FTDI_EEPROM_DIR))
	@$(call extract, FTDI_EEPROM)
	@$(call patchin, FTDI_EEPROM)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Prepare
# ----------------------------------------------------------------------------

ftdi_eeprom_prepare: $(STATEDIR)/ftdi_eeprom.prepare

FTDI_EEPROM_PATH	:= PATH=$(CROSS_PATH)
FTDI_EEPROM_ENV 	:= $(CROSS_ENV)

#
# autoconf
#
FTDI_EEPROM_AUTOCONF := $(CROSS_AUTOCONF_USR) \
		--disable-debug \
		--disable-dependency-tracking \
		HAVELIBFTDI="$(PTXCONF_CROSS_PREFIX)/bin/pkg-config libftdi"
# required, as long this packet uses libusb-config instead of pkgconfig

$(STATEDIR)/ftdi_eeprom.prepare: $(ftdi_eeprom_prepare_deps_default)
	@$(call targetinfo, $@)
	@$(call clean, $(FTDI_EEPROM_DIR)/config.cache)
	cd $(FTDI_EEPROM_DIR) && \
		$(FTDI_EEPROM_PATH) $(FTDI_EEPROM_ENV) \
		./configure $(FTDI_EEPROM_AUTOCONF)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Compile
# ----------------------------------------------------------------------------

ftdi_eeprom_compile: $(STATEDIR)/ftdi_eeprom.compile

$(STATEDIR)/ftdi_eeprom.compile: $(ftdi_eeprom_compile_deps_default)
	@$(call targetinfo, $@)
	cd $(FTDI_EEPROM_DIR) && $(FTDI_EEPROM_PATH) $(MAKE) $(PARALLELMFLAGS)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Install
# ----------------------------------------------------------------------------

ftdi_eeprom_install: $(STATEDIR)/ftdi_eeprom.install

$(STATEDIR)/ftdi_eeprom.install: $(ftdi_eeprom_install_deps_default)
	@$(call targetinfo, $@)
	@$(call install, FTDI_EEPROM)
	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Target-Install
# ----------------------------------------------------------------------------

ftdi_eeprom_targetinstall: $(STATEDIR)/ftdi_eeprom.targetinstall

$(STATEDIR)/ftdi_eeprom.targetinstall: $(ftdi_eeprom_targetinstall_deps_default)
	@$(call targetinfo, $@)

	@$(call install_init, ftdi_eeprom)
	@$(call install_fixup, ftdi_eeprom,PACKAGE,ftdieeprom)
	@$(call install_fixup, ftdi_eeprom,PRIORITY,optional)
	@$(call install_fixup, ftdi_eeprom,VERSION,$(FTDI_EEPROM_VERSION))
	@$(call install_fixup, ftdi_eeprom,SECTION,base)
	@$(call install_fixup, ftdi_eeprom,AUTHOR,"Juergen Beisert <juergen\@kreuzholzen.de>")
	@$(call install_fixup, ftdi_eeprom,DEPENDS,)
	@$(call install_fixup, ftdi_eeprom,DESCRIPTION,missing)

	@$(call install_copy, ftdi_eeprom, 0, 0, 0755, \
		$(FTDI_EEPROM_DIR)/ftdi_eeprom/ftdi_eeprom, \
		/usr/bin/ftdi_eeprom, y)

	@$(call install_finish, ftdi_eeprom)

	@$(call touch, $@)

# ----------------------------------------------------------------------------
# Clean
# ----------------------------------------------------------------------------

ftdi_eeprom_clean:
	rm -rf $(STATEDIR)/ftdi_eeprom.*
	rm -rf $(IMAGEDIR)/ftdi_eeprom_*
	rm -rf $(FTDI_EEPROM_DIR)

# vim: syntax=make
